{$R-,S-}
UNIT Graf16;
(**) INTERFACE (**)
CONST
  pRep = $00;
  pXor = $18;
  pAnd = $08;
  pOr  = $10;

  FUNCTION  IsEgaVga : Boolean;
  FUNCTION  IsVga : Boolean;
  PROCEDURE SetVidMode(M : Byte);
  PROCEDURE PutPixel16(X, Y, C : Word; upmode : Byte);
  FUNCTION  GetPixel16(X, Y : Word) : Byte;
  PROCEDURE SetRGB16(PalNum, R, G, B : Byte);
  PROCEDURE GetRGB16(PalNum : Byte; VAR R, G, B : Byte);
(**) IMPLEMENTATION (**)
CONST
  CRTC = $03CE;
  BytesPerLine16 = 80;

  FUNCTION IsEgaVga : Boolean; Assembler;
  ASM
    MOV AH, 12h  {fonction 12h, sous-fonction 10h}
    MOV BL, 10h  {"lecture de la configuration"}
    INT 10h
    MOV AL, 0    {retourne FALSE}
    CMP BH, 1    {0=couleur, 1=mono, >1=erreur}
    JA @NoEgaVga
    CMP BL, 3    {0..3=64k..256k RAM; >3=erreur}
    JA @NoEgaVga
    INC AL       {retourne TRUE}
    @NoEgaVga:
  END;

  FUNCTION IsVga : Boolean; Assembler;
  ASM
    MOV AH, 12h  {fonction 12h, sous-fonction 36h}
    MOV AL, 00h  {00 pour activer}
    MOV BL, 36h  {"active/dsactive le rafrachissement de l'cran"}
    INT 10h
    MOV AH, 0    {retourne FALSE}
    CMP AL, 12h  {AL=12h si succs}
    JNZ @NotVga
    INC AH       {retourne TRUE}
    @NotVga:
  END;

  PROCEDURE SetVidMode(M : Byte); Assembler;
  ASM
    MOV AH, 00   {fonction 0, "modification du mode vido"}
    MOV AL, M
    INT 10h
  END;

  PROCEDURE PutPixel16(X, Y, C : Word;
                       upmode : Byte); Assembler;
  ASM
    MOV AX, Y
    MOV BX, X
    MOV CL, BL
    PUSH DX
    MOV DX, BytesPerLine16
    MUL DX         {multiplie les lignes par le nombre d'octets/ligne}
    POP DX         {AX contient le dbut de la ligne}
    SHR BX,1
    SHR BX,1
    SHR BX,1
    ADD BX, AX     {BX contient l'offset du buffer}
    MOV AX, 0A000h
    MOV ES, AX     {ES:BX pointe sur l'adresse du pixel}
    AND CL, 7
    XOR CL, 7      {dcalage  gauche (BIT address)}
    MOV AH, 1
    SHL AH, CL
    MOV DX, CRTC
    MOV AL, 8
    OUT DX, AX     {masque dsactiv pour tout exception faite de l'octet}
    MOV AX, 0005h
    OUT DX, AX     {Ecriture en Mode 0}
    MOV AH, upmode
    MOV AL, 3
    OUT DX, AX     {positionne le nouveau mode de pixel}
    MOV AH, Byte(C)
    MOV AL, 0
    OUT DX, AX     {active/reset}
    MOV AX, 0F01h
    OUT DX, AX     {active/reset par octet}
    OR ES:[BX], AL {FAIT CE QU'IL FAUT}
    MOV AX, 0FF08h {restaure le masque}
    OUT DX, AX
    MOV AX, 0003h  {restaure le nouveau mode pixel par dfaut}
    OUT DX, AX
    MOV AX, 0001   {active/reset par pixel}
    OUT DX, AX
  END;

  FUNCTION GetPixel16(X, Y : Word) : Byte; Assembler;
  ASM
    MOV AX, Y
    MOV BX, X
    MOV CL, BL
    PUSH DX
    MOV DX, BytesPerLine16
    MUL DX         {multiplie les lignes par le nombre d'octet/ligne}
    POP DX         {AX contient le dbut de la ligne}
    SHR BX,1
    SHR BX,1
    SHR BX,1
    ADD BX, AX     {BX contient l'offset du buffer}
    MOV AX, 0A000h
    MOV ES, AX     {ES:BX pointe sur l'adresse du pixel}
    AND CL, 7
    XOR CL, 7      {dcalage  gauche (BIT address)}
    MOV AH, 1
    MOV CH, AH
    SHL CH, CL     {CH contenait le bit de masque dans bonne configuration}
    MOV SI, BX     {ES:SI pointe sur l'octet dans la RAM vido}
    MOV DX, CRTC
    MOV AX, 304h   {commence avec le plan 3}
    XOR BL, BL     {nous thsaurisons les valeurs dans BL}
    @Loop:
    OUT DX, AX
    MOV BH, ES:[SI]
    AND BH, CH
    NEG BH
    ROL BX, 1
    DEC AH
    JGE @Loop
    MOV AL, BL     {rsultat dans AL}
  END;

  PROCEDURE SetRGB16(PalNum, R, G, B : Byte); Assembler;
  ASM
    MOV AH, 10h   {fonc. 10h, sous-fonc. 07h}
    MOV AL, 07h   {"Modification du registre de palette"}
    MOV BL, PalNum
    INT 10h
    XOR BL, BL
    XCHG BH, BL   {BX contient maintenant la couleur}
    MOV AH, 10h   {fonc. 10h, sous-fonc. 10h}
    MOV AL, 10h   {"Modification du registre de couleur"}
    MOV DH, R
    MOV CH, G
    MOV CL, B
    INT 10h
  END;

  PROCEDURE GetRGB16(PalNum : Byte;
                   VAR R, G, B : Byte); Assembler;
  ASM
    MOV AH, 10h   {fonc. 10h, sous-fonc. 07h}
    MOV AL, 07h   {"Lecture du registre de palette"}
    MOV BL, PalNum
    INT 10h
    XOR BL, BL
    XCHG BH, BL   {BX contient maintenant la couleur}
    MOV AH, 10h   {fonc. 10h, sous-fonc. 10h}
    MOV AL, 15h   {"Lecture du registre de couleur"}
    INT 10h
    LES DI, R
    MOV ES:[DI], DH
    LES DI, G
    MOV ES:[DI], CH
    LES DI, B
    MOV ES:[DI], CL
  END;
END.
